;*****WINDOW MESSAGES***********************************************************
CREATE_WM:
                            ;Create the edit control child window
 S1=WS_CHILD OR WS_VISIBLE OR WS_HSCROLL OR WS_VSCROLL OR WS_BORDER OR \
    ES_LEFT OR ES_MULTILINE OR ES_AUTOHSCROLL OR ES_AUTOVSCROLL OR ES_NOHIDESEL

 INVOKE CreateWindowEx,EBP,TEXT('EDIT',0),EBP,S1,EBP,EBP,EBP,\
                       EBP,ESI,EDITID,[hInst],EBP
 MOV [hwndEdit],EAX

 INVOKE SendMessage,EAX,EM_LIMITTEXT,32000,EBP
                            ;Initialize common dialog box stuff
 INVOKIT PopFileInitialize,ESI

 INVOKIT PopFontInitialize,ESI

 INVOKE RegisterWindowMessage,TEXT(FINDMSGSTRING,0)
 MOV [messageFindReplace],AX

 INVOKIT DoCaption,ESI,@ szTitleName

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
SETFOCUS_WM:
 INVOKE SetFocus,[hwndEdit]

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
SIZE_WM:
 MOVZX EAX,DX               ;EAX=LOWORD(lParam)
 SHR EDX,16                 ;EDX=HIWORD(lParam)
 INVOKE MoveWindow,[hwndEdit],EBP,EBP,EAX,EDX,ESI ;ESI=TRUE,EBP=0

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
INITMENUPOPUP_WM:
 .IF EDX==1                 ;Edit menu
                            ;Enable Undo if edit control can do it
   INVOKE SendMessage,[hwndEdit],EM_CANUNDO,EBP,EBP

   XOR ECX,ECX              ;ECX=MF_ENABLED=0
   TEST EAX,EAX
   .IF ZERO?                ;check if can undo menu item
     INC ECX                ;ECX=1=MF_GRAYED
   .ENDIF

   INVOKE EnableMenuItem,EBX,IDM_EDIT_UNDO,ECX

                            ;Enable Paste if text is in the clipboard
   INVOKE IsClipboardFormatAvailable,CF_TEXT

   TEST EAX,EAX
   .IF ZERO?                ;check if can undo menu item
     INC EBP                ;EBP=1=MF_GRAYED, EBP was 0
   .ENDIF

   INVOKE EnableMenuItem,EBX,IDM_EDIT_PASTE,EBP ;EBP=MF_ENABLED or MF_GRAYED
                            ;Enable Cut, Copy, and Del if text is selected
   LEA EDI,[ESP.CALLBACKIT.iSelEnd]
   LEA EBP,[ESP.CALLBACKIT.iSelBeg]

   INVOKE SendMessage,[hwndEdit],EM_GETSEL,EBP,EDI

   XOR ESI,ESI              ;ESI=MF_ENABLED=0
   .IF EBP == EDI           ;is beginning the same as end?
     INC ESI                ;ESI=1=MF_GRAYED
   .ENDIF

   INVOKE EnableMenuItem,EBX,IDM_EDIT_CUT,ESI
   INVOKE EnableMenuItem,EBX,IDM_EDIT_COPY,ESI
   INVOKE EnableMenuItem,EBX,IDM_EDIT_CLEAR,ESI

   XOR EAX,EAX
   JMP MAINCBRET

 .ENDIF

 .IF EDX==2                 ;Search menu
                            ;EnableFind, Next, and Replace if modeless
                            ;dialogs are not already active
   XOR ESI,ESI              ;ESI=MF_ENABLED=0
   .IF [hDlgModeless]
     INC ESI                ;MF_GRAYED=1
   .ENDIF

   INVOKE EnableMenuItem,EBX,IDM_SEARCH_FIND,ESI
   INVOKE EnableMenuItem,EBX,IDM_SEARCH_NEXT,ESI
   INVOKE EnableMenuItem,EBX,IDM_SEARCH_REPLACE,ESI
 .ENDIF

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
COMMAND_WM:                 ;Messages from edit control
 TEST EDX,EDX
 .IF !ZERO? && BX==EDITID      ;EDX=lParam
   MOV ECX,EBX              ;EBX=ECX=wParam
   XOR EAX,EAX
   SHR ECX,16               ;ECX=HIWORD(wParam)

   .IF ECX==EN_UPDATE       ;ECX=HIWORD(wParam)
     MOV [bNeedSave],ESI    ;ESI=TRUE
     JMP MAINCBRET
   .ENDIF

   CMP ECX,EN_ERRSPACE      ;check for error
   JZ @F
   CMP ECX,EN_MAXTEXT       ;check for error
   JNZ DEFWINRET            ;continue on if no errors
   @@:
    INVOKE MessageBox,ESI,TEXT('Edit control out of space.',0),\
                      @ szAppName,MB_OK OR MB_ICONSTOP
    XOR EAX,EAX
    JMP MAINCBRET
 .ENDIF
;-------------------------------------------------------------------------------
                            ;Messages from File menu
;-------------------------------------------------------------------------------
 MOV EAX,EBX             ;LOWORD(wParam)
 MOV ECX,CMDENT1         ;number of entries in command message number table
 MOV EDI,@ CMDNTAB1      ;command message number table address
 REPNE SCASW             ;search table for message number
 JNZ DefWindowProcA      ;message not found--immediate jump to default handler
                         ;command message number has been found
 MOVSX ECX,W[CMDATAB1-CMDNTAB1-WORD+EDI]
 ADD ECX,@ FILE_NEW_IDM
 JMP ECX
;-------------------------------------------------------------------------------
FILE_NEW_IDM:
 .IF [bNeedSave]
   INVOKIT AskAboutSave,ESI,@ szTitleName

   .IF EAX==IDCANCEL
     XOR EAX,EAX
     RET
   .ENDIF
 .ENDIF

 INVOKE SetWindowText,[hwndEdit],LTEXT(ENDZERO,0)

 MOV [szFileName],0
 MOV [szTitleName],0

 INVOKIT DoCaption,ESI,@ szTitleName

 MOV [bNeedSave],EBP        ;EBP=0=FALSE

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
FILE_OPEN_IDM:
 .IF [bNeedSave]
   INVOKIT AskAboutSave,ESI,@ szTitleName

   .IF EAX==IDCANCEL
     XOR EAX,EAX
     JMP MAINCBRET
   .ENDIF
 .ENDIF

 INVOKIT PopFileOpenDlg,ESI,@ szFileName,@ szTitleName

 .IF EAX
   INVOKIT PopFileRead,[hwndEdit],@ szFileName

   .IF !EAX
     INVOKIT OkMessage,ESI,TEXT('Could not read file %s!',0),@ szTitleName

     MOV [szFileName],0
     MOV [szTitleName],0
   .ENDIF
 .ENDIF

 INVOKIT DoCaption,ESI,@ szTitleName

 MOV [bNeedSave],EBP        ;EBP=0=FALSE

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
FILE_SAVE_IDM:
 .IF [szFileName[0]]
   INVOKIT PopFileWrite,[hwndEdit],@ szFileName

   .IF EAX
     MOV [bNeedSave],EBP
     MOV EAX,ESI            ;EAX=ESI=TRUE
     JMP MAINCBRET
   .ENDIF

   INVOKIT OkMessage,ESI,LTEXT(CNWFILE,'Could not write file %s',0),@ szTitleName

   XOR EAX,EAX
   JMP MAINCBRET
 .ENDIF
                            ;fall through
;-------------------------------------------------------------------------------
FILE_SAVE_AS_IDM:
 INVOKIT PopFileSaveDlg,ESI,@ szFileName,@ szTitleName

 .IF EAX
   INVOKIT DoCaption,ESI,@ szTitleName

   INVOKIT PopFileWrite,[hwndEdit],@ szFileName

   .IF EAX
     MOV [bNeedSave],EBP
     MOV EAX,ESI            ;EAX=ESI=TRUE
     JMP MAINCBRET
   .ENDIF

   INVOKIT OkMessage,ESI,@ CNWFILE,@ szTitleName
 .ENDIF

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
FILE_PRINT_IDM:
 INVOKIT PopPrntPrintFile,[hInst],ESI,[hwndEdit],@ szTitleName

 .IF !EAX
   INVOKIT OkMessage,ESI,TEXT('Could not print file %s',0),@ szTitleName
 .ENDIF

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
APP_EXIT_IDM:
 INVOKE SendMessage,ESI,WM_CLOSE,EBP,EBP

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
                            ;Messages from Edit Menu
;-------------------------------------------------------------------------------
EDIT_UNDO_IDM:
 INVOKE SendMessage,[hwndEdit],WM_UNDO,EBP,EBP

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
EDIT_CUT_IDM:
 INVOKE SendMessage,[hwndEdit],WM_CUT,EBP,EBP

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
EDIT_COPY_IDM:
 INVOKE SendMessage,[hwndEdit],WM_COPY,EBP,EBP

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
EDIT_PASTE_IDM:
 INVOKE SendMessage,[hwndEdit],WM_PASTE,EBP,EBP

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
EDIT_CLEAR_IDM:
 INVOKE SendMessage,[hwndEdit],WM_CLEAR,EBP,EBP

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
EDIT_SELECT_ALL_IDM:
 INVOKE SendMessage,[hwndEdit],EM_SETSEL,EBP,-1

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
                            ;Messages from Search menu
;-------------------------------------------------------------------------------
SEARCH_FIND_IDM:
 INVOKE SendMessage,[hwndEdit],EM_GETSEL,EBP,@ iOffset

 INVOKIT PopFindFindDlg,ESI
 MOV [hDlgModeless],EAX

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
SEARCH_NEXT_IDM:
 INVOKE SendMessage,[hwndEdit],EM_GETSEL,EBP,@ iOffset

 MOVZX EAX,[szFindText[0]]

 .IF EAX
   INVOKIT PopFindNextText,[hwndEdit],@ iOffset

   TEST EAX,EAX
   .IF ZERO?
     INVOKIT OkMessage,ESI,@ TXTNF,@ ENDZERO
   .ENDIF
 .ELSE
   INVOKIT PopFindFindDlg,ESI
   MOV [hDlgModeless],EAX
 .ENDIF

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
SEARCH_REPLACE_IDM:
 INVOKE SendMessage,[hwndEdit],EM_GETSEL,EBP,@ iOffset

 INVOKIT PopFindReplaceDlg,ESI
 MOV [hDlgModeless],EAX

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
FORMAT_FONT_IDM:
 INVOKIT PopFontChooseFont,ESI

 .IF EAX
   INVOKIT PopFontSetFont,[hwndEdit]
 .ENDIF

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
                            ;Messages from Help menu
;-------------------------------------------------------------------------------
HELP_IDM:
 INVOKIT OkMessage,ESI,TEXT('Help not yet implemented!',0),@ ENDZERO

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
APP_ABOUT_IDM:
 INVOKE DialogBoxParam,[hInst],TEXT('AboutBox',0),ESI,@ AboutDlgProc,EBP

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
CLOSE_WM:
 .IF ![bNeedSave]
@@:
   INVOKE DestroyWindow,ESI
 .ELSE
   INVOKIT AskAboutSave,ESI,@ szTitleName

   .IF EAX!=IDCANCEL
     JMP @B
   .ENDIF
 .ENDIF

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
QUERYENDSESSION_WM:
 .IF ![bNeedSave]
   JMP MAINCBRET            ;EAX=WM_QUERYENDSESSION=TRUE
 .ENDIF

 INVOKIT AskAboutSave,ESI,@ szTitleName

 .IF EAX!=IDCANCEL
   JMP MAINCBRET            ;EAX=WM_QUERYENDSESSION=TRUE
 .ENDIF

 XOR EAX,EAX                ;EAX=FALSE=0
 JMP MAINCBRET
;-------------------------------------------------------------------------------
DESTROY_WM:
 INVOKE DeleteObject,[hFont]

 INVOKE PostQuitMessage,EBP     ;EBP=0

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
MFREPLACE:                  ;Process "Find-Replace" messages
 MOV EBX,[fr.Flags]

 .IF EBX & FR_DIALOGTERM
    MOV  [hDlgModeless],EBP
 .ENDIF

 .IF EBX & FR_FINDNEXT
   INVOKIT PopFindFindText,[hwndEdit],@ iOffset,@ fr

   .IF !EAX
     INVOKIT OkMessage,ESI,LTEXT(TXTNF,'Text not found!',0),@ ENDZERO
   .ENDIF
 .ENDIF

 .IF (EBX & FR_REPLACE) || (EBX & FR_REPLACEALL)
   INVOKIT PopFindReplaceText,[hwndEdit],@ iOffset,@ fr

   .IF !EAX
     INVOKIT OkMessage,ESI,@ TXTNF,@ ENDZERO ;Text not found'
   .ENDIF
 .ENDIF

 .IF EBX & FR_REPLACEALL
   .REPEAT
     INVOKIT PopFindReplaceText,[hwndEdit],@ iOffset,@ fr
   .UNTIL !EAX
 .ENDIF

 XOR EAX,EAX
 JMP MAINCBRET
;-------------------------------------------------------------------------------
                            ;dialog box messages
;-------------------------------------------------------------------------------
INITDIALOG_WM:
 MOV EAX,ESI                ;return TRUE
 JMP DIAGBOXRET
;-------------------------------------------------------------------------------
COMMAND1_WM:
 MOVZX EAX,BX               ;EAX=LOWORD(wParam)

 .IF EAX==IDOK
   INVOKE EndDialog,ESI,EBP ;ESI=hDlg

   JMP DIAGBOXRET           ;EAX=TRUE if EndDialog succeeded
 .ENDIF
                            ;fall through
;-------------------------------------------------------------------------------
DLGBK1:
 XOR EAX,EAX
 RET 4*DWORD                ;return FALSE
 ;*****END OF WINDOW MESSAGES****************************************************

